#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
  PKG = mini-cipa-dripa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: me.pgoblin.m4,v 1.1 2019/09/27 19:08:16 babolo Exp $

#connect 0001
CIPA_DBMS
GETENV(, 1, 1)dnl
#echo    Q
##Q copy E
#style   00Q00Q
Q
#perform 0001
CREATE TEMP TABLE x
     ( u text    --    (${USER})
     )
;
#perform 0001
INSERT INTO x
 SELECT (SELECT e FROM e WHERE n = 'USER' AND regexp('^[a-z0-9_]+$', e))
;
#select  1001
SELECT 'pgsql dbname='
    || COALESCE(NULLIF('PROTOVER', ''), 'minicipa')
    || ' requirepeer=postgres application_name=minicipa'
;
#connect 0102
#close   101
#select  0002
SELECT '*****  Illegal user ', current_user, ' must be postgres  *****'
 WHERE current_user::text IS DISTINCT FROM 'postgres'
;
#select  1002
SELECT '#exit
' WHERE current_user::text IS DISTINCT FROM 'postgres'
;
#eval    01
#select  u001  #####################################################################  u - ${USER}  ####
SELECT u FROM x;
#select  10u2  ##################################################  CREATE ROLE ${USER} WITH LOGIN  ####
SELECT 'CREATE ROLE ' || r || ' WITH LOGIN;
'FROM  (SELECT $1::text AS r)r
  LEFT JOIN pg_catalog.pg_roles ON(r.r = pg_roles.rolname::text)
 WHERE pg_roles.rolname IS NULL
;
#perform 0102
#select  10u2  #######################################################  GRANT operator TO ${USER}  ####
SELECT 'GRANT operator TO ' || $1::text || ';';
#perform 0102
